#include <iostream>

using namespace std;


int main()
{
    int n,q,l,r;
    cin >> n >> q;
    int A[n];
    int odg[q];
    for(int i=1;i<=n;i++)
        cin >> A[i];
    for(int i=0;i<q;i++)
    {
        cin >> l >> r;
        for(int j=r;j>=l;j--)
        {
            if(A[j]==0)
                {
                odg[i]=0;
                break;
                }
            else
                odg[i]=1;
        }
    }
    for(int i=0;i<q;i++)
        cout << odg[i] << endl;
    return 0;
}